{
Copyright (C) 2004  by Dirk Paehl http://www.paehl.de


This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307, USA.

Auf Deutsch:

Copyright (C) 2004  by Dirk Paehl http://www.paehl.de

Dieses Programm ist freie Software. Sie können es unter den
    Bedingungen der GNU General Public License, wie von der Free
    Software Foundation veröffentlicht, weitergeben und/oder
    modifizieren, entweder gemäß Version 2 der Lizenz oder (nach Ihrer
    Option) jeder späteren Version.

Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß
    es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar
    ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT
    FÜR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General
    Public License.

Sie sollten eine Kopie der GNU General Public License zusammen mit
    diesem Programm erhalten haben. Falls nicht, schreiben Sie an die
    Free Software Foundation, Inc., 59 Temple Place, Suite 330,
    Boston, MA 02111-1307, USA.

}

unit unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Buttons,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    catfrom: TEdit;
    catto: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Panel1: TPanel;
    permissions: TCheckGroup;
    Edit1: TEdit;
    edit2: TEdit;
    owner_pw: TEdit;
    Label4: TLabel;
    RadioGroup2: TRadioGroup;
    SaveDialog1: TSaveDialog;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    user_pw: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    RadioGroup1: TRadioGroup;
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click( Sender: TObject);
    procedure Button14Click( Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Form1Create(Sender: TObject);
  private
   pdffile: string;
   pdftk_path: string;
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation
uses unix;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Shell('echo Hello World!');
  close;
end;

procedure TForm1.Button10Click(Sender: TObject);
var target,hilf : string;
    s: LongInt;
begin
if not OpenDialog1.Execute then exit;
target:=changefileext(extractfilename(OpenDialog1.Filename),'_uncompress.pdf');
hilf:='"'+OpenDialog1.Filename+'" output "'+target+'" uncompress';
setcurrentdir(extractfilepath(Opendialog1.Filename));
S:=Shell(pdftk_path+' '+hilf);
 if s = 0 then  Showmessage('PDF was decrypt') else
  Showmessage('ERROR CODE: '+IntToStr(1))
end;

procedure TForm1.Button11Click(Sender: TObject);
var target,hilf : string;
    s: longint;
begin
if not OpenDialog1.Execute then exit;
target:=changefileext(extractfilename(OpenDialog1.Filename),'');

setcurrentdir(extractfilepath(Opendialog1.Filename));
if not directoryexists(target) then mkdir(target);
setcurrentdir(target);

hilf:='"'+OpenDialog1.Filename+'" dump_data output input_report.txt';

S:=Shell(pdftk_path+' '+hilf);
 if s = 0 then Showmessage('PDF was decrypt') else
  Showmessage('ERROR CODE: '+IntToStr(1));
end;

procedure TForm1.Button12Click(Sender: TObject);
var hilf,datei,qualifier :string;
    s:LongInt;
begin
if ( (catfrom.Text='') or (catto.Text='') ) then
begin
  showmessage('CAT FROM: and CAT TO: must be insert');
  exit;
end;
if not OpenDialog1.Execute then exit;

datei:=changefileext(extractfilename(OpenDialog1.Filename),'')+'_cat.pdf';
datei:='"'+extractfilepath(OpenDialog1.Filename)+datei+'"';
case RadioGroup2.ItemIndex of
  0:qualifier:='';
  1:qualifier:='even';
  2:qualifier:='odd';
 end;

hilf:=format('%s "A=%s" cat A%s-%s%s output %s',[pdftk_path,OpenDialog1.Filename,catfrom.text,catto.text,qualifier,datei]);
S:=Shell(hilf);
Showmessage('PDF was created: Status:'+IntToStr(S));
end;

procedure TForm1. Button13Click( Sender: TObject);
 var return_value,datei,hilf:string;
     s :LongInt;
begin
 return_value := InputBox(
      'Remove page'
     ,'Remove page: Sample remove Page 13'
     ,'A1-12 A14-end');

if return_value='' then exit;

if not OpenDialog1.Execute then exit;
datei:=changefileext(extractfilename(OpenDialog1.Filename),'')+'_remove.pdf';
datei:='"'+extractfilepath(OpenDialog1.Filename)+datei+'"';
hilf:=format('%s "A=%s" cat %s output %s',[pdftk_path,OpenDialog1.Filename,return_value,datei]);
S:=Shell(hilf);
Showmessage('PDF was created: Status:'+IntToStr(S));
end;

 procedure TForm1. Button14Click( Sender: TObject);
 var outf,target : String;
     s: LongInt;
begin
  if not SelectDirectoryDialog1.execute then exit;
  OpenDialog1.Title:='Save the target PDF file for combine';
  if not OpenDialog1.Execute then exit;
  target:=OpenDialog1.Filename;
  outf:=format('%s %s/*.pdf cat output "%s"',[pdftk_path,SelectDirectoryDialog1.FileName,target]);
  OpenDialog1.Title:='Choose the PDF file';
  S:=Shell('echo '+outf);
  S:=Shell(outf);

  Showmessage('PDF was created: Status:'+IntToStr(S));
end;

 procedure TForm1.Button15Click(Sender: TObject);
 var outf:Ansistring;
     s:longint;
     dateien:TStrings;
     datei:string;
     i:integer;
 begin
  OPenDialog1.options:=[ofAllowMultiselect,ofEnableSizing];
  if opendialog1.execute then
  begin
   dateien:=TStringList.create;
   Dateien:=OPenDialog1.Files;
   datei:='';
   for i:= 0 to dateien.count - 1 do
    datei:=datei+' "'+dateien[i]+'" ';
   dateien.free;
   OPendialog1.Title:='Save the target PDF file for merge';
   if SaveDialog1.execute then
   begin
    outf:=format('%s %s cat output "%s"',[pdftk_path,datei,SaveDialog1.filename]);
     S:=Shell('echo '+outf);
     S:=Shell(outf);
    Showmessage('PDF was created: Status:'+IntToStr(S));
    end;
  end;
 OPenDialog1.options:=[ofEnableSizing];
 end;

procedure TForm1.Button2Click(Sender: TObject);
   var hilf : string;
begin
  if not opendialog1.Execute then exit;
  pdffile:=opendialog1.FileName;
  hilf:=changefileext(extractfilename(pdffile),'');
  edit1.Text:=pdffile;
  Edit2.Text:=extractfilepath(pdffile)+hilf+'_sec.pdf';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if not SaveDialog1.execute then exit;
  Edit2.Text:=SaveDialog1.filename;
end;

procedure TForm1.Button4Click(Sender: TObject);
var crypt,userpass,ownerpass,outs,perms : string;
    S: Longint;
begin
if (user_pw.text = owner_pw.text) then
 begin
  Showmessage('User and Owner password must be different');
  exit;
 end;

perms:='';
if permissions.checked[0] then perms :='printing';
if permissions.checked[1] then perms :=perms+' degradeprinting';
if permissions.checked[2] then perms :=perms+' ModifyContents';
if permissions.checked[3] then perms :=perms+' Assembly';
if permissions.checked[4] then perms :=perms+' CopyContents';
if permissions.checked[5] then perms :=perms+' ScreenReaders';
if permissions.checked[6] then perms :=perms+' ModifyAnnotations';
if permissions.checked[7] then perms :=perms+' FillLn';
if permissions.checked[8] then perms :='AllFeatures';
if perms <>'' then perms:='allow '+perms;

if edit1.text = '' then
 begin
   Showmessage('Choose a PDF file first');
   exit;
 end;
  case radiogroup1.ItemIndex of
   0: crypt :='encrypt_40bits';
   1: crypt :='encrypt_128bits';
  end;

  if user_pw.Text <> '' then userpass :='user_pw '+user_pw.text;
  if owner_pw.Text <> '' then ownerpass :='owner_pw '+owner_pw.text;
  outs := format('%s %s output %s %s %s %s %s',[pdftk_path,edit1.Text,edit2.Text,crypt,ownerpass,userpass,perms]);
  S:=Shell(outs);

  Showmessage('PDF was created: Status:'+IntToStr(S));
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  showmessage('GUI for PDFTK 0.93 or higher is (c) by Dirk Paehl 2004'#13#10+'Mainsite: http://www.paehl.de');
end;

procedure TForm1.Button6Click(Sender: TObject);
var ownerpw,hilf:string;
    S: LongInt;
begin
  if edit1.text = '' then
 begin
   Showmessage('Choose a PDF file first');
   exit;
 end;
 
ownerpw:='input_pw '+owner_pw.text;
hilf := format('%s %s %s output %s',[pdftk_path,edit1.Text,ownerpw,edit2.text]);
S:=Shell(hilf);
 if s = 0 then
  Showmessage('PDF was decrypt') else
  Showmessage('ERROR CODE: '+IntToStr(1));
end;

procedure TForm1.Button7Click(Sender: TObject);
var hilf,datei : string;
    s: LongInt;
begin
showmessage('Repair a corrupted PDF, if possible (this can take a long time on a large file)');
if not OpenDialog1.Execute then exit;
datei:=changefileext(extractfilename(OpenDialog1.Filename),'')+'_fixed.pdf';
datei:='"'+extractfilepath(OpenDialog1.Filename)+datei+'"';
setcurrentdir(extractfilepath(Opendialog1.Filename));

hilf:='"'+OpenDialog1.Filename+'" output '+datei;
S:=Shell(pdftk_path+' '+hilf);
 if s = 0 then
  Showmessage('PDF was decrypt') else
  Showmessage('ERROR CODE: '+IntToStr(1));
  
end;

procedure TForm1.Button8Click(Sender: TObject);
var target,hilf : string;
    s: longint;
begin
showmessage('Burst a PDF document into single pages, optionally applying encryption. This also creates a document report, doc_data.txt, that lists metadata and bookmark information.');
if not OpenDialog1.Execute then exit;

target:=changefileext(extractfilename(OpenDialog1.Filename),'');
setcurrentdir(extractfilepath(Opendialog1.Filename));
if not directoryexists(target) then mkdir(target);
setcurrentdir(target);

hilf:='"'+OpenDialog1.Filename+'" burst';

S:=Shell(pdftk_path+' '+hilf);
 if s = 0 then  Showmessage('PDF was decrypt') else
  Showmessage('ERROR CODE: '+IntToStr(1))
end;

procedure TForm1.Button9Click(Sender: TObject);
var target,hilf : string;
    s: LongInt;
begin
if not OpenDialog1.Execute then exit;
target:=changefileext(extractfilename(OpenDialog1.Filename),'_compress.pdf');
hilf:='"'+OpenDialog1.Filename+'" output "'+target+'" compress';
setcurrentdir(extractfilepath(Opendialog1.Filename));
S:=Shell(pdftk_path+' '+hilf);
 if s = 0 then  Showmessage('PDF was decrypt') else
  Showmessage('ERROR CODE: '+IntToStr(1))
end;

procedure TForm1.Form1Create(Sender: TObject);
var f: Textfile;
    path: string;
begin
   Assignfile(f,extractfilepath(application.exename)+'guipdftk.config');
   Filemode:=0;
   try
    reset(f);
    readln(f,path);
   finally
    closefile(f);
   end;
   if fileexists(path+'pdftk') then
   begin
    pdftk_path := path+'pdftk';
   end else
   begin
   pdftk_path := extractfilepath(application.exename)+'pdftk';
   if not fileexists(pdftk_path) then
   begin
    Showmessage('ERROR: PDFTK not found. More infos on my site. http://pdf.paehl.de');
    halt(1);
   end;
   end;
    // showmessage(pdftk_path);

end;

initialization
  {$I unit1.lrs}

end.

